<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Light.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_light_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Light.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_light_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#ifndef _H_LIGHT_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#define _H_LIGHT_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_surface_8hpp.html">Surface.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_material_8hpp.html">Material.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_sphere_8hpp.html">Sphere.hpp</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="class_light.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_light.html">Light</a> {</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="class_light.html#a2b2d9c78fdb73ac943a6a35b221f1cfd">   20</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_light.html#a2b2d9c78fdb73ac943a6a35b221f1cfd">local_o</a>; </div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_light.html#a40e3c201ef2e17b89e937833f2da9111">   23</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_light.html#a40e3c201ef2e17b89e937833f2da9111">o</a>; </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="class_light.html#aa556ccba60a14514c231438403b55db0">   26</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_light.html#aa556ccba60a14514c231438403b55db0">cl</a>; </div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_light.html#ae028a60a89a219e6eff0ff1b24482a71">   29</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_light.html#ae028a60a89a219e6eff0ff1b24482a71">decay</a>; </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="class_light.html#a37ee0b241dbdaff4a13cc269de33a8bf">   32</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_light.html#a37ee0b241dbdaff4a13cc269de33a8bf">on</a>; </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="class_light.html#aeb8b1184fc6cf93bbcc205f50bd004c8">   35</a></span>&#160;    <a class="code" href="class_surface.html">Surface</a> *<a class="code" href="class_light.html#aeb8b1184fc6cf93bbcc205f50bd004c8">geode</a>; </div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="class_light.html#a33549e9047c9103a2fdf43be0825407f">   38</a></span>&#160;    <a class="code" href="class_transform.html">Transform</a> *<a class="code" href="class_light.html#a33549e9047c9103a2fdf43be0825407f">tf</a>; </div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <a class="code" href="class_light.html#aa603d04b2e28195a4819e34ad2604df6">Light</a> (<a class="code" href="class_vec.html">Vec</a> _o, <a class="code" href="class_vec.html">Vec</a> _cl, <span class="keywordtype">double</span> _decay, <a class="code" href="class_surface.html">Surface</a> *_geode);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <a class="code" href="class_light.html#aa603d04b2e28195a4819e34ad2604df6">Light</a> (<a class="code" href="class_vec.html">Vec</a> _o, <a class="code" href="class_vec.html">Vec</a> _cl, <span class="keywordtype">double</span> _decay);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="class_light.html#af1ae0f3ac995d07909a6fe6f2cc9ddb4">   63</a></span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_light.html#af1ae0f3ac995d07909a6fe6f2cc9ddb4">setTransform</a>(<a class="code" href="class_transform.html">Transform</a> *_tf) {tf = _tf;}</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_light.html#ab8637968f4709709716577ca196f5e74">transform</a>();</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;};</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_light_html_ae028a60a89a219e6eff0ff1b24482a71"><div class="ttname"><a href="class_light.html#ae028a60a89a219e6eff0ff1b24482a71">Light::decay</a></div><div class="ttdeci">double decay</div><div class="ttdoc">Light intensity decay exponent. </div><div class="ttdef"><b>Definition:</b> Light.hpp:29</div></div>
<div class="ttc" id="class_surface_html"><div class="ttname"><a href="class_surface.html">Surface</a></div><div class="ttdoc">A base class for every geometry class (e.g., Sphere, Triangle, Mesh). </div><div class="ttdef"><b>Definition:</b> Surface.hpp:40</div></div>
<div class="ttc" id="class_light_html"><div class="ttname"><a href="class_light.html">Light</a></div><div class="ttdoc">A class to create and manipulate light sources. </div><div class="ttdef"><b>Definition:</b> Light.hpp:16</div></div>
<div class="ttc" id="class_light_html_aa603d04b2e28195a4819e34ad2604df6"><div class="ttname"><a href="class_light.html#aa603d04b2e28195a4819e34ad2604df6">Light::Light</a></div><div class="ttdeci">Light(Vec _o, Vec _cl, double _decay, Surface *_geode)</div><div class="ttdef"><b>Definition:</b> Light.cpp:9</div></div>
<div class="ttc" id="class_light_html_a2b2d9c78fdb73ac943a6a35b221f1cfd"><div class="ttname"><a href="class_light.html#a2b2d9c78fdb73ac943a6a35b221f1cfd">Light::local_o</a></div><div class="ttdeci">Vec local_o</div><div class="ttdoc">Light source&amp;#39;s original location, as defined in the Constructor. </div><div class="ttdef"><b>Definition:</b> Light.hpp:20</div></div>
<div class="ttc" id="class_light_html_a40e3c201ef2e17b89e937833f2da9111"><div class="ttname"><a href="class_light.html#a40e3c201ef2e17b89e937833f2da9111">Light::o</a></div><div class="ttdeci">Vec o</div><div class="ttdoc">Light source&amp;#39;s transformed location, after applying setTransform() </div><div class="ttdef"><b>Definition:</b> Light.hpp:23</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_light_html_af1ae0f3ac995d07909a6fe6f2cc9ddb4"><div class="ttname"><a href="class_light.html#af1ae0f3ac995d07909a6fe6f2cc9ddb4">Light::setTransform</a></div><div class="ttdeci">virtual void setTransform(Transform *_tf)</div><div class="ttdoc">Associates a Transform node to this light source. The method transform() can then be used to change t...</div><div class="ttdef"><b>Definition:</b> Light.hpp:63</div></div>
<div class="ttc" id="class_light_html_aeb8b1184fc6cf93bbcc205f50bd004c8"><div class="ttname"><a href="class_light.html#aeb8b1184fc6cf93bbcc205f50bd004c8">Light::geode</a></div><div class="ttdeci">Surface * geode</div><div class="ttdoc">Pointer to Surface associated to this Light source. </div><div class="ttdef"><b>Definition:</b> Light.hpp:35</div></div>
<div class="ttc" id="class_light_html_a33549e9047c9103a2fdf43be0825407f"><div class="ttname"><a href="class_light.html#a33549e9047c9103a2fdf43be0825407f">Light::tf</a></div><div class="ttdeci">Transform * tf</div><div class="ttdoc">Pointer to Transform node set via setTransform() </div><div class="ttdef"><b>Definition:</b> Light.hpp:38</div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_light_html_ab8637968f4709709716577ca196f5e74"><div class="ttname"><a href="class_light.html#ab8637968f4709709716577ca196f5e74">Light::transform</a></div><div class="ttdeci">void transform()</div><div class="ttdoc">Transforms the light source&amp;#39;s location according to the Transform node passed with setTransform() ...</div><div class="ttdef"><b>Definition:</b> Light.cpp:18</div></div>
<div class="ttc" id="_sphere_8hpp_html"><div class="ttname"><a href="_sphere_8hpp.html">Sphere.hpp</a></div></div>
<div class="ttc" id="_material_8hpp_html"><div class="ttname"><a href="_material_8hpp.html">Material.hpp</a></div></div>
<div class="ttc" id="class_light_html_aa556ccba60a14514c231438403b55db0"><div class="ttname"><a href="class_light.html#aa556ccba60a14514c231438403b55db0">Light::cl</a></div><div class="ttdeci">Vec cl</div><div class="ttdoc">Light&amp;#39;s intensity vector. </div><div class="ttdef"><b>Definition:</b> Light.hpp:26</div></div>
<div class="ttc" id="_surface_8hpp_html"><div class="ttname"><a href="_surface_8hpp.html">Surface.hpp</a></div></div>
<div class="ttc" id="class_light_html_a37ee0b241dbdaff4a13cc269de33a8bf"><div class="ttname"><a href="class_light.html#a37ee0b241dbdaff4a13cc269de33a8bf">Light::on</a></div><div class="ttdeci">bool on</div><div class="ttdoc">Flag stating whether the light source is on or off. </div><div class="ttdef"><b>Definition:</b> Light.hpp:32</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_light_8hpp.html">Light.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
